FIND(1)

NAME
find - find files

SYNOPSIS
find pathname-list expression
find pattern

DESCRIPTION
In the first form above, find recursively descends the directory hierarchy for each pathname in the pathname-list (i.e., one or more pathnames) seeking files that match a boolean expression written in the primaries given below. In the descriptions, the argument n is used as a decimal integer where +n means more than n, -n means less than n and n means exactly n.

The second form rapidly searches a database for all pathnames which match pattern. Usually the database is recomputed weekly (by running the the script /usr/lib/find/updatedb from the weekly administration script /var/adm/weekly) and contains the pathnames of all files which are publicly accessible. If escaped, normal shell “globbing” characters (`*', `?', `[', and ']') may be used in pattern, but the matching differs in that no characters (e.g. `/') have to be matched explicitly. As a special case, a simple pattern containing no globbing characters is matched as though it were *pattern*; if any globbing character appears there are no implicit globbing characters.

-fstype type
    True if the filesystem to which the file belongs matches type. Type is usually either 4.3 or nfs.

-name filename
    True if the filename argument matches the current file name. Normal shell argument syntax may be used if escaped (watch out for `[', `?' and `*').

-perm onum
    True if the file permission flags exactly match the octal number onum (see chmod(1)). If onum is prefixed by a minus sign, more flag bits (017777, see stat(2)) become significant and the flags are compared: (flags&onum)==onum.

-prune
    Always true, but has the side effect of not descending if the current file is a directory.

-type c
    True if the type of the file is c, where c is b, c, d, f, p, l or s for block special file, character special file, directory, plain file, pipe, symbolic link, or socket.

-links n
    True if the file has n links.

-user uname
    True if the file belongs to the user uname (login name or numeric user ID).

-nouser
    True if the file belongs to a user not in the /etc/passwd database.

-group gname
    True if the file belongs to group gname (group name or numeric group ID).

-nogroup
    True if the file belongs to a group not in the /etc/group database.

-size n[c]
    True if the file is n blocks long (512 bytes per block). If n is followed by a c, then the size is in bytes.

-inum n
    True if the file has inode number n.

-atime n
    True if the file has been accessed in n days.

-mtime n
    True if the file has been modified in n days.

-ctime n
    True if the file has been changed in n days. `Changed' means that either the contents or some attribute of the file have been modified within the time specified.

-exec command
    True if the executed command returns a zero value as exit status. The end of the command must be punctuated by an escaped semicolon. A command argument `{}' is replaced by the current pathname.

-ok command
    Like -exec except that the generated command is written on the standard output, then the standard input is read and the command executed only upon response y.

-print
    Always true; causes the current pathname to be printed.

-ls Always true; causes current pathname to be printed together with its associated statistics. These include (respectively) inode number, size in kilobytes (1024 bytes), protection mode, number of hard links, user, group, size in bytes, and modification time. If the file is a special file the size field will instead contain the major and minor device numbers. If the file is a symbolic link the pathname of the linked-to file is printed preceded by ``->''. The format is identical to that of ``ls -gilds'' (note however that formatting is done internally, without executing the ls program).

-newer file
    True if the current file has been modified more recently than the argument file.

-cpio file
    Write the current file on the argument file in cpio format, with large blocksize, i.e. with a blocksize of 5120 bytes. This blocksize is compatible with the -B option of cpio.

-ncpio file
    Write the current file on the argument file in character-header cpio format, with large blocksize. This format is compatible with the -c option of cpio, (however the latter always reads the first block to determine whether the file was created using -cpio or -ncpio. It is therefore unnecessary to specify the -c option to cpio). This format is preferable for portability, but the destination file is larger.

-depth
    Search subdirectories of each directory recursively before examining the contents directory itself. This is automatically implied by the -cpio and -ncpio options. This enables the modification and access times of the directory to be restored after the contents of the directory have been recovered, as normally the act of recovering the files updates the modification time of the containing directories.

-xdev
    Always true; causes find not to traverse down into a file system different from the one on which current argument pathname resides.

The primaries may be combined using the following operators (in order of decreasing precedence):

1)  A parenthesized group of primaries and operators (parentheses are special to the Shell and must be escaped).

2)  The negation of a primary (`!' is the unary not operator).

3)  Concatenation of primaries (the and operation is implied by the juxtaposition of two primaries).

4)  Alternation of primaries (`-o' is the or operator).

EXAMPLES

To find all accessible files whose pathname contains `find':

    find find

To typeset all variants of manual pages for `ls':

    vtroff -man `find '*man*/ls.?'`

To remove all files named `a.out' or `*.o' that have not been accessed for a week:

    find / \( -name a.out -o -name '*.o' \) -atime +7 -exec rm {} \;

To recursively print all file names in the current directory and below, but ignoring the contents of all RCS directories:

    find . -print -name RCS -prune

FILES
/etc/passwd
/etc/group
/var/find/find.codes	coded pathnames database

SEE ALSO
sh(1), test(1), cpio(1), cpio(5), fs(5).
Relevant paper in February, 1983 issue of ;login:.

BUGS
The first form's syntax is painful, and the second form's exact semantics is confusing and can vary from site to site.

More than one `-newer' option does not work properly.